import { type StartHoldMusicOperation } from '../../../../../../models/startHoldMusicOperation';
import { type StartHoldMusicPostRequestBody } from './startHoldMusicPostRequestBody';
import { BaseRequestBuilder, RequestInformation, type RequestAdapter, type RequestConfiguration } from '@microsoft/kiota-abstractions';
/**
 * Provides operations to call the startHoldMusic method.
 */
export declare class StartHoldMusicRequestBuilder extends BaseRequestBuilder {
    /**
     * Instantiates a new StartHoldMusicRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Put a participant on hold and play music in the background.
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of StartHoldMusicOperation
     * @see {@link https://learn.microsoft.com/graph/api/participant-startholdmusic?view=graph-rest-1.0|Find more info here}
     */
    post(body: StartHoldMusicPostRequestBody, requestConfiguration?: RequestConfiguration<object> | undefined): Promise<StartHoldMusicOperation | undefined>;
    /**
     * Put a participant on hold and play music in the background.
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toPostRequestInformation(body: StartHoldMusicPostRequestBody, requestConfiguration?: RequestConfiguration<object> | undefined): RequestInformation;
    /**
     * Returns a request builder with the provided arbitrary URL. Using this method means any other path or query parameters are ignored.
     * @param rawUrl The raw URL to use for the request builder.
     * @returns a startHoldMusicRequestBuilder
     */
    withUrl(rawUrl: string): StartHoldMusicRequestBuilder;
}
