"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MobileAppItemRequestBuilder = void 0;
// tslint:disable
// eslint-disable
// Generated by Microsoft Kiota
const mobileApp_1 = require("../../../models/mobileApp");
const oDataError_1 = require("../../../models/oDataErrors/oDataError");
const assignRequestBuilder_1 = require("./assign/assignRequestBuilder");
const assignmentsRequestBuilder_1 = require("./assignments/assignmentsRequestBuilder");
const categoriesRequestBuilder_1 = require("./categories/categoriesRequestBuilder");
const graphAndroidLobAppRequestBuilder_1 = require("./graphAndroidLobApp/graphAndroidLobAppRequestBuilder");
const graphAndroidStoreAppRequestBuilder_1 = require("./graphAndroidStoreApp/graphAndroidStoreAppRequestBuilder");
const graphIosLobAppRequestBuilder_1 = require("./graphIosLobApp/graphIosLobAppRequestBuilder");
const graphIosStoreAppRequestBuilder_1 = require("./graphIosStoreApp/graphIosStoreAppRequestBuilder");
const graphIosVppAppRequestBuilder_1 = require("./graphIosVppApp/graphIosVppAppRequestBuilder");
const graphMacOSDmgAppRequestBuilder_1 = require("./graphMacOSDmgApp/graphMacOSDmgAppRequestBuilder");
const graphMacOSLobAppRequestBuilder_1 = require("./graphMacOSLobApp/graphMacOSLobAppRequestBuilder");
const graphManagedAndroidLobAppRequestBuilder_1 = require("./graphManagedAndroidLobApp/graphManagedAndroidLobAppRequestBuilder");
const graphManagedIOSLobAppRequestBuilder_1 = require("./graphManagedIOSLobApp/graphManagedIOSLobAppRequestBuilder");
const graphManagedMobileLobAppRequestBuilder_1 = require("./graphManagedMobileLobApp/graphManagedMobileLobAppRequestBuilder");
const graphMicrosoftStoreForBusinessAppRequestBuilder_1 = require("./graphMicrosoftStoreForBusinessApp/graphMicrosoftStoreForBusinessAppRequestBuilder");
const graphWin32LobAppRequestBuilder_1 = require("./graphWin32LobApp/graphWin32LobAppRequestBuilder");
const graphWindowsAppXRequestBuilder_1 = require("./graphWindowsAppX/graphWindowsAppXRequestBuilder");
const graphWindowsMobileMSIRequestBuilder_1 = require("./graphWindowsMobileMSI/graphWindowsMobileMSIRequestBuilder");
const graphWindowsUniversalAppXRequestBuilder_1 = require("./graphWindowsUniversalAppX/graphWindowsUniversalAppXRequestBuilder");
const graphWindowsWebAppRequestBuilder_1 = require("./graphWindowsWebApp/graphWindowsWebAppRequestBuilder");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
/**
 * Provides operations to manage the mobileApps property of the microsoft.graph.deviceAppManagement entity.
 */
class MobileAppItemRequestBuilder extends kiota_abstractions_1.BaseRequestBuilder {
    /**
     * Provides operations to call the assign method.
     */
    get assign() {
        return new assignRequestBuilder_1.AssignRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Provides operations to manage the assignments property of the microsoft.graph.mobileApp entity.
     */
    get assignments() {
        return new assignmentsRequestBuilder_1.AssignmentsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Provides operations to manage the categories property of the microsoft.graph.mobileApp entity.
     */
    get categories() {
        return new categoriesRequestBuilder_1.CategoriesRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to androidLobApp.
     */
    get graphAndroidLobApp() {
        return new graphAndroidLobAppRequestBuilder_1.GraphAndroidLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to androidStoreApp.
     */
    get graphAndroidStoreApp() {
        return new graphAndroidStoreAppRequestBuilder_1.GraphAndroidStoreAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to iosLobApp.
     */
    get graphIosLobApp() {
        return new graphIosLobAppRequestBuilder_1.GraphIosLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to iosStoreApp.
     */
    get graphIosStoreApp() {
        return new graphIosStoreAppRequestBuilder_1.GraphIosStoreAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to iosVppApp.
     */
    get graphIosVppApp() {
        return new graphIosVppAppRequestBuilder_1.GraphIosVppAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to macOSDmgApp.
     */
    get graphMacOSDmgApp() {
        return new graphMacOSDmgAppRequestBuilder_1.GraphMacOSDmgAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to macOSLobApp.
     */
    get graphMacOSLobApp() {
        return new graphMacOSLobAppRequestBuilder_1.GraphMacOSLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to managedAndroidLobApp.
     */
    get graphManagedAndroidLobApp() {
        return new graphManagedAndroidLobAppRequestBuilder_1.GraphManagedAndroidLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to managedIOSLobApp.
     */
    get graphManagedIOSLobApp() {
        return new graphManagedIOSLobAppRequestBuilder_1.GraphManagedIOSLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to managedMobileLobApp.
     */
    get graphManagedMobileLobApp() {
        return new graphManagedMobileLobAppRequestBuilder_1.GraphManagedMobileLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to microsoftStoreForBusinessApp.
     */
    get graphMicrosoftStoreForBusinessApp() {
        return new graphMicrosoftStoreForBusinessAppRequestBuilder_1.GraphMicrosoftStoreForBusinessAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to win32LobApp.
     */
    get graphWin32LobApp() {
        return new graphWin32LobAppRequestBuilder_1.GraphWin32LobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to windowsAppX.
     */
    get graphWindowsAppX() {
        return new graphWindowsAppXRequestBuilder_1.GraphWindowsAppXRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to windowsMobileMSI.
     */
    get graphWindowsMobileMSI() {
        return new graphWindowsMobileMSIRequestBuilder_1.GraphWindowsMobileMSIRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to windowsUniversalAppX.
     */
    get graphWindowsUniversalAppX() {
        return new graphWindowsUniversalAppXRequestBuilder_1.GraphWindowsUniversalAppXRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to windowsWebApp.
     */
    get graphWindowsWebApp() {
        return new graphWindowsWebAppRequestBuilder_1.GraphWindowsWebAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Instantiates a new MobileAppItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters, requestAdapter) {
        super(pathParameters, requestAdapter, "{+baseurl}/deviceAppManagement/mobileApps/{mobileApp%2Did}{?%24select,%24expand}");
    }
    ;
    /**
     * Deletes a windowsMicrosoftEdgeApp.
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @see {@link https://learn.microsoft.com/graph/api/intune-apps-windowsmicrosoftedgeapp-delete?view=graph-rest-1.0|Find more info here}
     */
    delete(requestConfiguration) {
        const requestInfo = this.toDeleteRequestInformation(requestConfiguration);
        const errorMapping = {
            "4XX": oDataError_1.createODataErrorFromDiscriminatorValue,
            "5XX": oDataError_1.createODataErrorFromDiscriminatorValue,
        };
        return this.requestAdapter.sendNoResponseContentAsync(requestInfo, errorMapping);
    }
    ;
    /**
     * Read properties and relationships of the managedIOSStoreApp object.
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of MobileApp
     * @see {@link https://learn.microsoft.com/graph/api/intune-apps-managediosstoreapp-get?view=graph-rest-1.0|Find more info here}
     */
    get(requestConfiguration) {
        const requestInfo = this.toGetRequestInformation(requestConfiguration);
        const errorMapping = {
            "4XX": oDataError_1.createODataErrorFromDiscriminatorValue,
            "5XX": oDataError_1.createODataErrorFromDiscriminatorValue,
        };
        return this.requestAdapter.sendAsync(requestInfo, mobileApp_1.createMobileAppFromDiscriminatorValue, errorMapping);
    }
    ;
    /**
     * Update the properties of a managedAndroidStoreApp object.
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of MobileApp
     * @see {@link https://learn.microsoft.com/graph/api/intune-apps-managedandroidstoreapp-update?view=graph-rest-1.0|Find more info here}
     */
    patch(body, requestConfiguration) {
        const requestInfo = this.toPatchRequestInformation(body, requestConfiguration);
        const errorMapping = {
            "4XX": oDataError_1.createODataErrorFromDiscriminatorValue,
            "5XX": oDataError_1.createODataErrorFromDiscriminatorValue,
        };
        return this.requestAdapter.sendAsync(requestInfo, mobileApp_1.createMobileAppFromDiscriminatorValue, errorMapping);
    }
    ;
    /**
     * Deletes a windowsMicrosoftEdgeApp.
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toDeleteRequestInformation(requestConfiguration) {
        const requestInfo = new kiota_abstractions_1.RequestInformation(kiota_abstractions_1.HttpMethod.DELETE, this.urlTemplate, this.pathParameters);
        requestInfo.configure(requestConfiguration);
        requestInfo.headers.tryAdd("Accept", "application/json");
        return requestInfo;
    }
    ;
    /**
     * Read properties and relationships of the managedIOSStoreApp object.
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toGetRequestInformation(requestConfiguration) {
        const requestInfo = new kiota_abstractions_1.RequestInformation(kiota_abstractions_1.HttpMethod.GET, this.urlTemplate, this.pathParameters);
        requestInfo.configure(requestConfiguration, mobileAppItemRequestBuilderGetQueryParametersMapper);
        requestInfo.headers.tryAdd("Accept", "application/json");
        return requestInfo;
    }
    ;
    /**
     * Update the properties of a managedAndroidStoreApp object.
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toPatchRequestInformation(body, requestConfiguration) {
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = new kiota_abstractions_1.RequestInformation(kiota_abstractions_1.HttpMethod.PATCH, this.urlTemplate, this.pathParameters);
        requestInfo.configure(requestConfiguration);
        requestInfo.headers.tryAdd("Accept", "application/json");
        requestInfo.setContentFromParsable(this.requestAdapter, "application/json", body, mobileApp_1.serializeMobileApp);
        return requestInfo;
    }
    ;
    /**
     * Returns a request builder with the provided arbitrary URL. Using this method means any other path or query parameters are ignored.
     * @param rawUrl The raw URL to use for the request builder.
     * @returns a MobileAppItemRequestBuilder
     */
    withUrl(rawUrl) {
        if (!rawUrl)
            throw new Error("rawUrl cannot be undefined");
        return new MobileAppItemRequestBuilder(rawUrl, this.requestAdapter);
    }
    ;
}
exports.MobileAppItemRequestBuilder = MobileAppItemRequestBuilder;
const mobileAppItemRequestBuilderGetQueryParametersMapper = {
    "expand": "%24expand",
    "select": "%24select",
};
// tslint:enable
// eslint-enable
