"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MobileAppsRequestBuilder = void 0;
const mobileApp_1 = require("../../models/mobileApp");
const mobileAppCollectionResponse_1 = require("../../models/mobileAppCollectionResponse");
const oDataError_1 = require("../../models/oDataErrors/oDataError");
const countRequestBuilder_1 = require("./count/countRequestBuilder");
const graphAndroidLobAppRequestBuilder_1 = require("./graphAndroidLobApp/graphAndroidLobAppRequestBuilder");
const graphAndroidStoreAppRequestBuilder_1 = require("./graphAndroidStoreApp/graphAndroidStoreAppRequestBuilder");
const graphIosLobAppRequestBuilder_1 = require("./graphIosLobApp/graphIosLobAppRequestBuilder");
const graphIosStoreAppRequestBuilder_1 = require("./graphIosStoreApp/graphIosStoreAppRequestBuilder");
const graphIosVppAppRequestBuilder_1 = require("./graphIosVppApp/graphIosVppAppRequestBuilder");
const graphMacOSDmgAppRequestBuilder_1 = require("./graphMacOSDmgApp/graphMacOSDmgAppRequestBuilder");
const graphMacOSLobAppRequestBuilder_1 = require("./graphMacOSLobApp/graphMacOSLobAppRequestBuilder");
const graphManagedAndroidLobAppRequestBuilder_1 = require("./graphManagedAndroidLobApp/graphManagedAndroidLobAppRequestBuilder");
const graphManagedIOSLobAppRequestBuilder_1 = require("./graphManagedIOSLobApp/graphManagedIOSLobAppRequestBuilder");
const graphManagedMobileLobAppRequestBuilder_1 = require("./graphManagedMobileLobApp/graphManagedMobileLobAppRequestBuilder");
const graphMicrosoftStoreForBusinessAppRequestBuilder_1 = require("./graphMicrosoftStoreForBusinessApp/graphMicrosoftStoreForBusinessAppRequestBuilder");
const graphWin32LobAppRequestBuilder_1 = require("./graphWin32LobApp/graphWin32LobAppRequestBuilder");
const graphWindowsAppXRequestBuilder_1 = require("./graphWindowsAppX/graphWindowsAppXRequestBuilder");
const graphWindowsMobileMSIRequestBuilder_1 = require("./graphWindowsMobileMSI/graphWindowsMobileMSIRequestBuilder");
const graphWindowsUniversalAppXRequestBuilder_1 = require("./graphWindowsUniversalAppX/graphWindowsUniversalAppXRequestBuilder");
const graphWindowsWebAppRequestBuilder_1 = require("./graphWindowsWebApp/graphWindowsWebAppRequestBuilder");
const mobileAppItemRequestBuilder_1 = require("./item/mobileAppItemRequestBuilder");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
/**
 * Provides operations to manage the mobileApps property of the microsoft.graph.deviceAppManagement entity.
 */
class MobileAppsRequestBuilder extends kiota_abstractions_1.BaseRequestBuilder {
    /**
     * Provides operations to count the resources in the collection.
     */
    get count() {
        return new countRequestBuilder_1.CountRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to androidLobApp.
     */
    get graphAndroidLobApp() {
        return new graphAndroidLobAppRequestBuilder_1.GraphAndroidLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to androidStoreApp.
     */
    get graphAndroidStoreApp() {
        return new graphAndroidStoreAppRequestBuilder_1.GraphAndroidStoreAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to iosLobApp.
     */
    get graphIosLobApp() {
        return new graphIosLobAppRequestBuilder_1.GraphIosLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to iosStoreApp.
     */
    get graphIosStoreApp() {
        return new graphIosStoreAppRequestBuilder_1.GraphIosStoreAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to iosVppApp.
     */
    get graphIosVppApp() {
        return new graphIosVppAppRequestBuilder_1.GraphIosVppAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to macOSDmgApp.
     */
    get graphMacOSDmgApp() {
        return new graphMacOSDmgAppRequestBuilder_1.GraphMacOSDmgAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to macOSLobApp.
     */
    get graphMacOSLobApp() {
        return new graphMacOSLobAppRequestBuilder_1.GraphMacOSLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to managedAndroidLobApp.
     */
    get graphManagedAndroidLobApp() {
        return new graphManagedAndroidLobAppRequestBuilder_1.GraphManagedAndroidLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to managedIOSLobApp.
     */
    get graphManagedIOSLobApp() {
        return new graphManagedIOSLobAppRequestBuilder_1.GraphManagedIOSLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to managedMobileLobApp.
     */
    get graphManagedMobileLobApp() {
        return new graphManagedMobileLobAppRequestBuilder_1.GraphManagedMobileLobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to microsoftStoreForBusinessApp.
     */
    get graphMicrosoftStoreForBusinessApp() {
        return new graphMicrosoftStoreForBusinessAppRequestBuilder_1.GraphMicrosoftStoreForBusinessAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to win32LobApp.
     */
    get graphWin32LobApp() {
        return new graphWin32LobAppRequestBuilder_1.GraphWin32LobAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to windowsAppX.
     */
    get graphWindowsAppX() {
        return new graphWindowsAppXRequestBuilder_1.GraphWindowsAppXRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to windowsMobileMSI.
     */
    get graphWindowsMobileMSI() {
        return new graphWindowsMobileMSIRequestBuilder_1.GraphWindowsMobileMSIRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to windowsUniversalAppX.
     */
    get graphWindowsUniversalAppX() {
        return new graphWindowsUniversalAppXRequestBuilder_1.GraphWindowsUniversalAppXRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Casts the previous resource to windowsWebApp.
     */
    get graphWindowsWebApp() {
        return new graphWindowsWebAppRequestBuilder_1.GraphWindowsWebAppRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Provides operations to manage the mobileApps property of the microsoft.graph.deviceAppManagement entity.
     * @param mobileAppId The unique identifier of mobileApp
     * @returns a MobileAppItemRequestBuilder
     */
    byMobileAppId(mobileAppId) {
        if (!mobileAppId)
            throw new Error("mobileAppId cannot be undefined");
        const urlTplParams = (0, kiota_abstractions_1.getPathParameters)(this.pathParameters);
        urlTplParams["mobileApp%2Did"] = mobileAppId;
        return new mobileAppItemRequestBuilder_1.MobileAppItemRequestBuilder(urlTplParams, this.requestAdapter);
    }
    ;
    /**
     * Instantiates a new MobileAppsRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters, requestAdapter) {
        super(pathParameters, requestAdapter, "{+baseurl}/deviceAppManagement/mobileApps{?%24top,%24skip,%24search,%24filter,%24count,%24orderby,%24select,%24expand}");
    }
    ;
    /**
     * List properties and relationships of the windowsWebApp objects.
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of MobileAppCollectionResponse
     * @see {@link https://learn.microsoft.com/graph/api/intune-apps-windowswebapp-list?view=graph-rest-1.0|Find more info here}
     */
    get(requestConfiguration) {
        const requestInfo = this.toGetRequestInformation(requestConfiguration);
        const errorMapping = {
            "4XX": oDataError_1.createODataErrorFromDiscriminatorValue,
            "5XX": oDataError_1.createODataErrorFromDiscriminatorValue,
        };
        return this.requestAdapter.sendAsync(requestInfo, mobileAppCollectionResponse_1.createMobileAppCollectionResponseFromDiscriminatorValue, errorMapping);
    }
    ;
    /**
     * Create a new managedIOSLobApp object.
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of MobileApp
     * @see {@link https://learn.microsoft.com/graph/api/intune-apps-managedioslobapp-create?view=graph-rest-1.0|Find more info here}
     */
    post(body, requestConfiguration) {
        const requestInfo = this.toPostRequestInformation(body, requestConfiguration);
        const errorMapping = {
            "4XX": oDataError_1.createODataErrorFromDiscriminatorValue,
            "5XX": oDataError_1.createODataErrorFromDiscriminatorValue,
        };
        return this.requestAdapter.sendAsync(requestInfo, mobileApp_1.createMobileAppFromDiscriminatorValue, errorMapping);
    }
    ;
    /**
     * List properties and relationships of the windowsWebApp objects.
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toGetRequestInformation(requestConfiguration) {
        const requestInfo = new kiota_abstractions_1.RequestInformation(kiota_abstractions_1.HttpMethod.GET, this.urlTemplate, this.pathParameters);
        requestInfo.configure(requestConfiguration, mobileAppsRequestBuilderGetQueryParametersMapper);
        requestInfo.headers.tryAdd("Accept", "application/json");
        return requestInfo;
    }
    ;
    /**
     * Create a new managedIOSLobApp object.
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toPostRequestInformation(body, requestConfiguration) {
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = new kiota_abstractions_1.RequestInformation(kiota_abstractions_1.HttpMethod.POST, this.urlTemplate, this.pathParameters);
        requestInfo.configure(requestConfiguration);
        requestInfo.headers.tryAdd("Accept", "application/json");
        requestInfo.setContentFromParsable(this.requestAdapter, "application/json", body, mobileApp_1.serializeMobileApp);
        return requestInfo;
    }
    ;
    /**
     * Returns a request builder with the provided arbitrary URL. Using this method means any other path or query parameters are ignored.
     * @param rawUrl The raw URL to use for the request builder.
     * @returns a mobileAppsRequestBuilder
     */
    withUrl(rawUrl) {
        if (!rawUrl)
            throw new Error("rawUrl cannot be undefined");
        return new MobileAppsRequestBuilder(rawUrl, this.requestAdapter);
    }
    ;
}
exports.MobileAppsRequestBuilder = MobileAppsRequestBuilder;
const mobileAppsRequestBuilderGetQueryParametersMapper = {
    "count": "%24count",
    "expand": "%24expand",
    "filter": "%24filter",
    "orderby": "%24orderby",
    "search": "%24search",
    "select": "%24select",
    "skip": "%24skip",
    "top": "%24top",
};
// tslint:enable
// eslint-enable
