import { type DeviceManagementReports } from '../../models/deviceManagementReports';
import { ExportJobsRequestBuilder } from './exportJobs/exportJobsRequestBuilder';
import { GetCachedReportRequestBuilder } from './getCachedReport/getCachedReportRequestBuilder';
import { GetCompliancePolicyNonComplianceReportRequestBuilder } from './getCompliancePolicyNonComplianceReport/getCompliancePolicyNonComplianceReportRequestBuilder';
import { GetCompliancePolicyNonComplianceSummaryReportRequestBuilder } from './getCompliancePolicyNonComplianceSummaryReport/getCompliancePolicyNonComplianceSummaryReportRequestBuilder';
import { GetComplianceSettingNonComplianceReportRequestBuilder } from './getComplianceSettingNonComplianceReport/getComplianceSettingNonComplianceReportRequestBuilder';
import { GetConfigurationPolicyNonComplianceReportRequestBuilder } from './getConfigurationPolicyNonComplianceReport/getConfigurationPolicyNonComplianceReportRequestBuilder';
import { GetConfigurationPolicyNonComplianceSummaryReportRequestBuilder } from './getConfigurationPolicyNonComplianceSummaryReport/getConfigurationPolicyNonComplianceSummaryReportRequestBuilder';
import { GetConfigurationSettingNonComplianceReportRequestBuilder } from './getConfigurationSettingNonComplianceReport/getConfigurationSettingNonComplianceReportRequestBuilder';
import { GetDeviceManagementIntentPerSettingContributingProfilesRequestBuilder } from './getDeviceManagementIntentPerSettingContributingProfiles/getDeviceManagementIntentPerSettingContributingProfilesRequestBuilder';
import { GetDeviceManagementIntentSettingsReportRequestBuilder } from './getDeviceManagementIntentSettingsReport/getDeviceManagementIntentSettingsReportRequestBuilder';
import { GetDeviceNonComplianceReportRequestBuilder } from './getDeviceNonComplianceReport/getDeviceNonComplianceReportRequestBuilder';
import { GetDevicesWithoutCompliancePolicyReportRequestBuilder } from './getDevicesWithoutCompliancePolicyReport/getDevicesWithoutCompliancePolicyReportRequestBuilder';
import { GetHistoricalReportRequestBuilder } from './getHistoricalReport/getHistoricalReportRequestBuilder';
import { GetNoncompliantDevicesAndSettingsReportRequestBuilder } from './getNoncompliantDevicesAndSettingsReport/getNoncompliantDevicesAndSettingsReportRequestBuilder';
import { GetPolicyNonComplianceMetadataRequestBuilder } from './getPolicyNonComplianceMetadata/getPolicyNonComplianceMetadataRequestBuilder';
import { GetPolicyNonComplianceReportRequestBuilder } from './getPolicyNonComplianceReport/getPolicyNonComplianceReportRequestBuilder';
import { GetPolicyNonComplianceSummaryReportRequestBuilder } from './getPolicyNonComplianceSummaryReport/getPolicyNonComplianceSummaryReportRequestBuilder';
import { GetReportFiltersRequestBuilder } from './getReportFilters/getReportFiltersRequestBuilder';
import { GetSettingNonComplianceReportRequestBuilder } from './getSettingNonComplianceReport/getSettingNonComplianceReportRequestBuilder';
import { BaseRequestBuilder, RequestInformation, type RequestAdapter, type RequestConfiguration } from '@microsoft/kiota-abstractions';
export interface ReportsRequestBuilderGetQueryParameters {
    /**
     * Expand related entities
     */
    expand?: string[];
    /**
     * Select properties to be returned
     */
    select?: string[];
}
/**
 * Provides operations to manage the reports property of the microsoft.graph.deviceManagement entity.
 */
export declare class ReportsRequestBuilder extends BaseRequestBuilder {
    /**
     * Provides operations to manage the exportJobs property of the microsoft.graph.deviceManagementReports entity.
     */
    get exportJobs(): ExportJobsRequestBuilder;
    /**
     * Provides operations to call the getCachedReport method.
     */
    get getCachedReport(): GetCachedReportRequestBuilder;
    /**
     * Provides operations to call the getCompliancePolicyNonComplianceReport method.
     */
    get getCompliancePolicyNonComplianceReport(): GetCompliancePolicyNonComplianceReportRequestBuilder;
    /**
     * Provides operations to call the getCompliancePolicyNonComplianceSummaryReport method.
     */
    get getCompliancePolicyNonComplianceSummaryReport(): GetCompliancePolicyNonComplianceSummaryReportRequestBuilder;
    /**
     * Provides operations to call the getComplianceSettingNonComplianceReport method.
     */
    get getComplianceSettingNonComplianceReport(): GetComplianceSettingNonComplianceReportRequestBuilder;
    /**
     * Provides operations to call the getConfigurationPolicyNonComplianceReport method.
     */
    get getConfigurationPolicyNonComplianceReport(): GetConfigurationPolicyNonComplianceReportRequestBuilder;
    /**
     * Provides operations to call the getConfigurationPolicyNonComplianceSummaryReport method.
     */
    get getConfigurationPolicyNonComplianceSummaryReport(): GetConfigurationPolicyNonComplianceSummaryReportRequestBuilder;
    /**
     * Provides operations to call the getConfigurationSettingNonComplianceReport method.
     */
    get getConfigurationSettingNonComplianceReport(): GetConfigurationSettingNonComplianceReportRequestBuilder;
    /**
     * Provides operations to call the getDeviceManagementIntentPerSettingContributingProfiles method.
     */
    get getDeviceManagementIntentPerSettingContributingProfiles(): GetDeviceManagementIntentPerSettingContributingProfilesRequestBuilder;
    /**
     * Provides operations to call the getDeviceManagementIntentSettingsReport method.
     */
    get getDeviceManagementIntentSettingsReport(): GetDeviceManagementIntentSettingsReportRequestBuilder;
    /**
     * Provides operations to call the getDeviceNonComplianceReport method.
     */
    get getDeviceNonComplianceReport(): GetDeviceNonComplianceReportRequestBuilder;
    /**
     * Provides operations to call the getDevicesWithoutCompliancePolicyReport method.
     */
    get getDevicesWithoutCompliancePolicyReport(): GetDevicesWithoutCompliancePolicyReportRequestBuilder;
    /**
     * Provides operations to call the getHistoricalReport method.
     */
    get getHistoricalReport(): GetHistoricalReportRequestBuilder;
    /**
     * Provides operations to call the getNoncompliantDevicesAndSettingsReport method.
     */
    get getNoncompliantDevicesAndSettingsReport(): GetNoncompliantDevicesAndSettingsReportRequestBuilder;
    /**
     * Provides operations to call the getPolicyNonComplianceMetadata method.
     */
    get getPolicyNonComplianceMetadata(): GetPolicyNonComplianceMetadataRequestBuilder;
    /**
     * Provides operations to call the getPolicyNonComplianceReport method.
     */
    get getPolicyNonComplianceReport(): GetPolicyNonComplianceReportRequestBuilder;
    /**
     * Provides operations to call the getPolicyNonComplianceSummaryReport method.
     */
    get getPolicyNonComplianceSummaryReport(): GetPolicyNonComplianceSummaryReportRequestBuilder;
    /**
     * Provides operations to call the getReportFilters method.
     */
    get getReportFilters(): GetReportFiltersRequestBuilder;
    /**
     * Provides operations to call the getSettingNonComplianceReport method.
     */
    get getSettingNonComplianceReport(): GetSettingNonComplianceReportRequestBuilder;
    /**
     * Instantiates a new ReportsRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Delete navigation property reports for deviceManagement
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     */
    delete(requestConfiguration?: RequestConfiguration<object> | undefined): Promise<void>;
    /**
     * Read properties and relationships of the deviceManagementReports object.
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of DeviceManagementReports
     * @see {@link https://learn.microsoft.com/graph/api/intune-reporting-devicemanagementreports-get?view=graph-rest-1.0|Find more info here}
     */
    get(requestConfiguration?: RequestConfiguration<ReportsRequestBuilderGetQueryParameters> | undefined): Promise<DeviceManagementReports | undefined>;
    /**
     * Update the properties of a deviceManagementReports object.
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of DeviceManagementReports
     * @see {@link https://learn.microsoft.com/graph/api/intune-reporting-devicemanagementreports-update?view=graph-rest-1.0|Find more info here}
     */
    patch(body: DeviceManagementReports, requestConfiguration?: RequestConfiguration<object> | undefined): Promise<DeviceManagementReports | undefined>;
    /**
     * Delete navigation property reports for deviceManagement
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toDeleteRequestInformation(requestConfiguration?: RequestConfiguration<object> | undefined): RequestInformation;
    /**
     * Read properties and relationships of the deviceManagementReports object.
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toGetRequestInformation(requestConfiguration?: RequestConfiguration<ReportsRequestBuilderGetQueryParameters> | undefined): RequestInformation;
    /**
     * Update the properties of a deviceManagementReports object.
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toPatchRequestInformation(body: DeviceManagementReports, requestConfiguration?: RequestConfiguration<object> | undefined): RequestInformation;
    /**
     * Returns a request builder with the provided arbitrary URL. Using this method means any other path or query parameters are ignored.
     * @param rawUrl The raw URL to use for the request builder.
     * @returns a reportsRequestBuilder
     */
    withUrl(rawUrl: string): ReportsRequestBuilder;
}
