"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DirectoryRequestBuilder = void 0;
// tslint:disable
// eslint-disable
// Generated by Microsoft Kiota
const directory_1 = require("../models/directory");
const oDataError_1 = require("../models/oDataErrors/oDataError");
const administrativeUnitsRequestBuilder_1 = require("./administrativeUnits/administrativeUnitsRequestBuilder");
const attributeSetsRequestBuilder_1 = require("./attributeSets/attributeSetsRequestBuilder");
const customSecurityAttributeDefinitionsRequestBuilder_1 = require("./customSecurityAttributeDefinitions/customSecurityAttributeDefinitionsRequestBuilder");
const deletedItemsRequestBuilder_1 = require("./deletedItems/deletedItemsRequestBuilder");
const deviceLocalCredentialsRequestBuilder_1 = require("./deviceLocalCredentials/deviceLocalCredentialsRequestBuilder");
const federationConfigurationsRequestBuilder_1 = require("./federationConfigurations/federationConfigurationsRequestBuilder");
const onPremisesSynchronizationRequestBuilder_1 = require("./onPremisesSynchronization/onPremisesSynchronizationRequestBuilder");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
/**
 * Provides operations to manage the directory singleton.
 */
class DirectoryRequestBuilder extends kiota_abstractions_1.BaseRequestBuilder {
    /**
     * Provides operations to manage the administrativeUnits property of the microsoft.graph.directory entity.
     */
    get administrativeUnits() {
        return new administrativeUnitsRequestBuilder_1.AdministrativeUnitsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Provides operations to manage the attributeSets property of the microsoft.graph.directory entity.
     */
    get attributeSets() {
        return new attributeSetsRequestBuilder_1.AttributeSetsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Provides operations to manage the customSecurityAttributeDefinitions property of the microsoft.graph.directory entity.
     */
    get customSecurityAttributeDefinitions() {
        return new customSecurityAttributeDefinitionsRequestBuilder_1.CustomSecurityAttributeDefinitionsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Provides operations to manage the deletedItems property of the microsoft.graph.directory entity.
     */
    get deletedItems() {
        return new deletedItemsRequestBuilder_1.DeletedItemsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Provides operations to manage the deviceLocalCredentials property of the microsoft.graph.directory entity.
     */
    get deviceLocalCredentials() {
        return new deviceLocalCredentialsRequestBuilder_1.DeviceLocalCredentialsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Provides operations to manage the federationConfigurations property of the microsoft.graph.directory entity.
     */
    get federationConfigurations() {
        return new federationConfigurationsRequestBuilder_1.FederationConfigurationsRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Provides operations to manage the onPremisesSynchronization property of the microsoft.graph.directory entity.
     */
    get onPremisesSynchronization() {
        return new onPremisesSynchronizationRequestBuilder_1.OnPremisesSynchronizationRequestBuilder(this.pathParameters, this.requestAdapter);
    }
    /**
     * Instantiates a new DirectoryRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters, requestAdapter) {
        super(pathParameters, requestAdapter, "{+baseurl}/directory{?%24select,%24expand}");
    }
    ;
    /**
     * Get directory
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of Directory
     */
    get(requestConfiguration) {
        const requestInfo = this.toGetRequestInformation(requestConfiguration);
        const errorMapping = {
            "4XX": oDataError_1.createODataErrorFromDiscriminatorValue,
            "5XX": oDataError_1.createODataErrorFromDiscriminatorValue,
        };
        return this.requestAdapter.sendAsync(requestInfo, directory_1.createDirectoryFromDiscriminatorValue, errorMapping);
    }
    ;
    /**
     * Update directory
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of Directory
     */
    patch(body, requestConfiguration) {
        const requestInfo = this.toPatchRequestInformation(body, requestConfiguration);
        const errorMapping = {
            "4XX": oDataError_1.createODataErrorFromDiscriminatorValue,
            "5XX": oDataError_1.createODataErrorFromDiscriminatorValue,
        };
        return this.requestAdapter.sendAsync(requestInfo, directory_1.createDirectoryFromDiscriminatorValue, errorMapping);
    }
    ;
    /**
     * Get directory
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toGetRequestInformation(requestConfiguration) {
        const requestInfo = new kiota_abstractions_1.RequestInformation(kiota_abstractions_1.HttpMethod.GET, this.urlTemplate, this.pathParameters);
        requestInfo.configure(requestConfiguration, directoryRequestBuilderGetQueryParametersMapper);
        requestInfo.headers.tryAdd("Accept", "application/json");
        return requestInfo;
    }
    ;
    /**
     * Update directory
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toPatchRequestInformation(body, requestConfiguration) {
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = new kiota_abstractions_1.RequestInformation(kiota_abstractions_1.HttpMethod.PATCH, this.urlTemplate, this.pathParameters);
        requestInfo.configure(requestConfiguration);
        requestInfo.headers.tryAdd("Accept", "application/json");
        requestInfo.setContentFromParsable(this.requestAdapter, "application/json", body, directory_1.serializeDirectory);
        return requestInfo;
    }
    ;
    /**
     * Returns a request builder with the provided arbitrary URL. Using this method means any other path or query parameters are ignored.
     * @param rawUrl The raw URL to use for the request builder.
     * @returns a directoryRequestBuilder
     */
    withUrl(rawUrl) {
        if (!rawUrl)
            throw new Error("rawUrl cannot be undefined");
        return new DirectoryRequestBuilder(rawUrl, this.requestAdapter);
    }
    ;
}
exports.DirectoryRequestBuilder = DirectoryRequestBuilder;
const directoryRequestBuilderGetQueryParametersMapper = {
    "expand": "%24expand",
    "select": "%24select",
};
// tslint:enable
// eslint-enable
