"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InviteRequestBuilder = exports.serializeInvitePostResponse = exports.deserializeIntoInvitePostResponse = exports.createInvitePostResponseFromDiscriminatorValue = void 0;
// tslint:disable
// eslint-disable
// Generated by Microsoft Kiota
const baseCollectionPaginationCountResponse_1 = require("../../../../../models/baseCollectionPaginationCountResponse");
const oDataError_1 = require("../../../../../models/oDataErrors/oDataError");
const permission_1 = require("../../../../../models/permission");
const invitePostRequestBody_1 = require("./invitePostRequestBody");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
function createInvitePostResponseFromDiscriminatorValue(parseNode) {
    if (!parseNode)
        throw new Error("parseNode cannot be undefined");
    return deserializeIntoInvitePostResponse;
}
exports.createInvitePostResponseFromDiscriminatorValue = createInvitePostResponseFromDiscriminatorValue;
function deserializeIntoInvitePostResponse(invitePostResponse = {}) {
    return Object.assign(Object.assign({}, (0, baseCollectionPaginationCountResponse_1.deserializeIntoBaseCollectionPaginationCountResponse)(invitePostResponse)), { "value": n => { invitePostResponse.value = n.getCollectionOfObjectValues(permission_1.createPermissionFromDiscriminatorValue); } });
}
exports.deserializeIntoInvitePostResponse = deserializeIntoInvitePostResponse;
function serializeInvitePostResponse(writer, invitePostResponse = {}) {
    (0, baseCollectionPaginationCountResponse_1.serializeBaseCollectionPaginationCountResponse)(writer, invitePostResponse);
    writer.writeCollectionOfObjectValues("value", invitePostResponse.value, permission_1.serializePermission);
}
exports.serializeInvitePostResponse = serializeInvitePostResponse;
/**
 * Provides operations to call the invite method.
 */
class InviteRequestBuilder extends kiota_abstractions_1.BaseRequestBuilder {
    /**
     * Instantiates a new InviteRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters, requestAdapter) {
        super(pathParameters, requestAdapter, "{+baseurl}/drives/{drive%2Did}/items/{driveItem%2Did}/invite");
    }
    ;
    /**
     * Sends a sharing invitation for a driveItem.A sharing invitation provides permissions to the recipients and optionally sends them an email with a [sharing link][].
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of InvitePostResponse
     * @see {@link https://learn.microsoft.com/graph/api/driveitem-invite?view=graph-rest-1.0|Find more info here}
     */
    post(body, requestConfiguration) {
        const requestInfo = this.toPostRequestInformation(body, requestConfiguration);
        const errorMapping = {
            "4XX": oDataError_1.createODataErrorFromDiscriminatorValue,
            "5XX": oDataError_1.createODataErrorFromDiscriminatorValue,
        };
        return this.requestAdapter.sendAsync(requestInfo, createInvitePostResponseFromDiscriminatorValue, errorMapping);
    }
    ;
    /**
     * Sends a sharing invitation for a driveItem.A sharing invitation provides permissions to the recipients and optionally sends them an email with a [sharing link][].
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toPostRequestInformation(body, requestConfiguration) {
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = new kiota_abstractions_1.RequestInformation(kiota_abstractions_1.HttpMethod.POST, this.urlTemplate, this.pathParameters);
        requestInfo.configure(requestConfiguration);
        requestInfo.headers.tryAdd("Accept", "application/json");
        requestInfo.setContentFromParsable(this.requestAdapter, "application/json", body, invitePostRequestBody_1.serializeInvitePostRequestBody);
        return requestInfo;
    }
    ;
    /**
     * Returns a request builder with the provided arbitrary URL. Using this method means any other path or query parameters are ignored.
     * @param rawUrl The raw URL to use for the request builder.
     * @returns a inviteRequestBuilder
     */
    withUrl(rawUrl) {
        if (!rawUrl)
            throw new Error("rawUrl cannot be undefined");
        return new InviteRequestBuilder(rawUrl, this.requestAdapter);
    }
    ;
}
exports.InviteRequestBuilder = InviteRequestBuilder;
// tslint:enable
// eslint-enable
