import { type Json } from '../../../../../../../models/json';
import { type AdditionalDataHolder, type Parsable, type ParseNode, type SerializationWriter } from '@microsoft/kiota-abstractions';
export declare function createReceivedPostRequestBodyFromDiscriminatorValue(parseNode: ParseNode | undefined): typeof deserializeIntoReceivedPostRequestBody;
export declare function deserializeIntoReceivedPostRequestBody(receivedPostRequestBody?: ReceivedPostRequestBody | undefined): Record<string, (node: ParseNode) => void>;
export interface ReceivedPostRequestBody extends AdditionalDataHolder, Parsable {
    /**
     * Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     */
    additionalData?: Record<string, unknown>;
    /**
     * The basis property
     */
    basis?: Json;
    /**
     * The discount property
     */
    discount?: Json;
    /**
     * The investment property
     */
    investment?: Json;
    /**
     * The maturity property
     */
    maturity?: Json;
    /**
     * The settlement property
     */
    settlement?: Json;
}
export declare function serializeReceivedPostRequestBody(writer: SerializationWriter, receivedPostRequestBody?: ReceivedPostRequestBody | undefined): void;
