import { type Json } from '../../../../../../../models/json';
import { type AdditionalDataHolder, type Parsable, type ParseNode, type SerializationWriter } from '@microsoft/kiota-abstractions';
export declare function createYieldDiscPostRequestBodyFromDiscriminatorValue(parseNode: ParseNode | undefined): typeof deserializeIntoYieldDiscPostRequestBody;
export declare function deserializeIntoYieldDiscPostRequestBody(yieldDiscPostRequestBody?: YieldDiscPostRequestBody | undefined): Record<string, (node: ParseNode) => void>;
export declare function serializeYieldDiscPostRequestBody(writer: SerializationWriter, yieldDiscPostRequestBody?: YieldDiscPostRequestBody | undefined): void;
export interface YieldDiscPostRequestBody extends AdditionalDataHolder, Parsable {
    /**
     * Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     */
    additionalData?: Record<string, unknown>;
    /**
     * The basis property
     */
    basis?: Json;
    /**
     * The maturity property
     */
    maturity?: Json;
    /**
     * The pr property
     */
    pr?: Json;
    /**
     * The redemption property
     */
    redemption?: Json;
    /**
     * The settlement property
     */
    settlement?: Json;
}
