import { type HuntingQueryResults } from '../../models/security/huntingQueryResults';
import { type RunHuntingQueryPostRequestBody } from './runHuntingQueryPostRequestBody';
import { BaseRequestBuilder, RequestInformation, type RequestAdapter, type RequestConfiguration } from '@microsoft/kiota-abstractions';
/**
 * Provides operations to call the runHuntingQuery method.
 */
export declare class MicrosoftGraphSecurityRunHuntingQueryRequestBuilder extends BaseRequestBuilder {
    /**
     * Instantiates a new MicrosoftGraphSecurityRunHuntingQueryRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Invoke action runHuntingQuery
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of HuntingQueryResults
     */
    post(body: RunHuntingQueryPostRequestBody, requestConfiguration?: RequestConfiguration<object> | undefined): Promise<HuntingQueryResults | undefined>;
    /**
     * Invoke action runHuntingQuery
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toPostRequestInformation(body: RunHuntingQueryPostRequestBody, requestConfiguration?: RequestConfiguration<object> | undefined): RequestInformation;
    /**
     * Returns a request builder with the provided arbitrary URL. Using this method means any other path or query parameters are ignored.
     * @param rawUrl The raw URL to use for the request builder.
     * @returns a microsoftGraphSecurityRunHuntingQueryRequestBuilder
     */
    withUrl(rawUrl: string): MicrosoftGraphSecurityRunHuntingQueryRequestBuilder;
}
