"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetScheduleRequestBuilder = exports.serializeGetSchedulePostRequestBody = exports.deserializeIntoGetSchedulePostRequestBody = exports.createGetSchedulePostRequestBodyFromDiscriminatorValue = void 0;
// tslint:disable
// eslint-disable
// Generated by Microsoft Kiota
const dateTimeTimeZone_1 = require("../../../../../models/dateTimeTimeZone");
const oDataError_1 = require("../../../../../models/oDataErrors/oDataError");
const getSchedulePostResponse_1 = require("./getSchedulePostResponse");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
function createGetSchedulePostRequestBodyFromDiscriminatorValue(parseNode) {
    if (!parseNode)
        throw new Error("parseNode cannot be undefined");
    return deserializeIntoGetSchedulePostRequestBody;
}
exports.createGetSchedulePostRequestBodyFromDiscriminatorValue = createGetSchedulePostRequestBodyFromDiscriminatorValue;
function deserializeIntoGetSchedulePostRequestBody(getSchedulePostRequestBody = {}) {
    return {
        "availabilityViewInterval": n => { getSchedulePostRequestBody.availabilityViewInterval = n.getNumberValue(); },
        "endTime": n => { getSchedulePostRequestBody.endTime = n.getObjectValue(dateTimeTimeZone_1.createDateTimeTimeZoneFromDiscriminatorValue); },
        "schedules": n => { getSchedulePostRequestBody.schedules = n.getCollectionOfPrimitiveValues(); },
        "startTime": n => { getSchedulePostRequestBody.startTime = n.getObjectValue(dateTimeTimeZone_1.createDateTimeTimeZoneFromDiscriminatorValue); },
    };
}
exports.deserializeIntoGetSchedulePostRequestBody = deserializeIntoGetSchedulePostRequestBody;
function serializeGetSchedulePostRequestBody(writer, getSchedulePostRequestBody = {}) {
    writer.writeNumberValue("AvailabilityViewInterval", getSchedulePostRequestBody.availabilityViewInterval);
    writer.writeObjectValue("EndTime", getSchedulePostRequestBody.endTime, dateTimeTimeZone_1.serializeDateTimeTimeZone);
    writer.writeCollectionOfPrimitiveValues("Schedules", getSchedulePostRequestBody.schedules);
    writer.writeObjectValue("StartTime", getSchedulePostRequestBody.startTime, dateTimeTimeZone_1.serializeDateTimeTimeZone);
    writer.writeAdditionalData(getSchedulePostRequestBody.additionalData);
}
exports.serializeGetSchedulePostRequestBody = serializeGetSchedulePostRequestBody;
/**
 * Provides operations to call the getSchedule method.
 */
class GetScheduleRequestBuilder extends kiota_abstractions_1.BaseRequestBuilder {
    /**
     * Instantiates a new GetScheduleRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters, requestAdapter) {
        super(pathParameters, requestAdapter, "{+baseurl}/users/{user%2Did}/calendars/{calendar%2Did}/getSchedule");
    }
    ;
    /**
     * Get the free/busy availability information for a collection of users, distributions lists, or resources (rooms or equipment) for a specified time period.
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of GetSchedulePostResponse
     * @see {@link https://learn.microsoft.com/graph/api/calendar-getschedule?view=graph-rest-1.0|Find more info here}
     */
    post(body, requestConfiguration) {
        const requestInfo = this.toPostRequestInformation(body, requestConfiguration);
        const errorMapping = {
            "4XX": oDataError_1.createODataErrorFromDiscriminatorValue,
            "5XX": oDataError_1.createODataErrorFromDiscriminatorValue,
        };
        return this.requestAdapter.sendAsync(requestInfo, getSchedulePostResponse_1.createGetSchedulePostResponseFromDiscriminatorValue, errorMapping);
    }
    ;
    /**
     * Get the free/busy availability information for a collection of users, distributions lists, or resources (rooms or equipment) for a specified time period.
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toPostRequestInformation(body, requestConfiguration) {
        if (!body)
            throw new Error("body cannot be undefined");
        const requestInfo = new kiota_abstractions_1.RequestInformation(kiota_abstractions_1.HttpMethod.POST, this.urlTemplate, this.pathParameters);
        requestInfo.configure(requestConfiguration);
        requestInfo.headers.tryAdd("Accept", "application/json");
        requestInfo.setContentFromParsable(this.requestAdapter, "application/json", body, serializeGetSchedulePostRequestBody);
        return requestInfo;
    }
    ;
    /**
     * Returns a request builder with the provided arbitrary URL. Using this method means any other path or query parameters are ignored.
     * @param rawUrl The raw URL to use for the request builder.
     * @returns a getScheduleRequestBuilder
     */
    withUrl(rawUrl) {
        if (!rawUrl)
            throw new Error("rawUrl cannot be undefined");
        return new GetScheduleRequestBuilder(rawUrl, this.requestAdapter);
    }
    ;
}
exports.GetScheduleRequestBuilder = GetScheduleRequestBuilder;
// tslint:enable
// eslint-enable
