import { ClonableTeamParts } from '../../../../../models/clonableTeamParts';
import { TeamVisibilityType } from '../../../../../models/teamVisibilityType';
import { type AdditionalDataHolder, type Parsable, type ParseNode, type SerializationWriter } from '@microsoft/kiota-abstractions';
export interface ClonePostRequestBody extends AdditionalDataHolder, Parsable {
    /**
     * Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     */
    additionalData?: Record<string, unknown>;
    /**
     * The classification property
     */
    classification?: string;
    /**
     * The description property
     */
    description?: string;
    /**
     * The displayName property
     */
    displayName?: string;
    /**
     * The mailNickname property
     */
    mailNickname?: string;
    /**
     * The partsToClone property
     */
    partsToClone?: ClonableTeamParts[];
    /**
     * The visibility property
     */
    visibility?: TeamVisibilityType;
}
export declare function createClonePostRequestBodyFromDiscriminatorValue(parseNode: ParseNode | undefined): typeof deserializeIntoClonePostRequestBody;
export declare function deserializeIntoClonePostRequestBody(clonePostRequestBody?: ClonePostRequestBody | undefined): Record<string, (node: ParseNode) => void>;
export declare function serializeClonePostRequestBody(writer: SerializationWriter, clonePostRequestBody?: ClonePostRequestBody | undefined): void;
