import { type ManagedDevice } from '../../../../models/managedDevice';
import { BypassActivationLockRequestBuilder } from './bypassActivationLock/bypassActivationLockRequestBuilder';
import { CleanWindowsDeviceRequestBuilder } from './cleanWindowsDevice/cleanWindowsDeviceRequestBuilder';
import { DeleteUserFromSharedAppleDeviceRequestBuilder } from './deleteUserFromSharedAppleDevice/deleteUserFromSharedAppleDeviceRequestBuilder';
import { DeviceCategoryRequestBuilder } from './deviceCategory/deviceCategoryRequestBuilder';
import { DeviceCompliancePolicyStatesRequestBuilder } from './deviceCompliancePolicyStates/deviceCompliancePolicyStatesRequestBuilder';
import { DeviceConfigurationStatesRequestBuilder } from './deviceConfigurationStates/deviceConfigurationStatesRequestBuilder';
import { DisableLostModeRequestBuilder } from './disableLostMode/disableLostModeRequestBuilder';
import { LocateDeviceRequestBuilder } from './locateDevice/locateDeviceRequestBuilder';
import { LogCollectionRequestsRequestBuilder } from './logCollectionRequests/logCollectionRequestsRequestBuilder';
import { LogoutSharedAppleDeviceActiveUserRequestBuilder } from './logoutSharedAppleDeviceActiveUser/logoutSharedAppleDeviceActiveUserRequestBuilder';
import { RebootNowRequestBuilder } from './rebootNow/rebootNowRequestBuilder';
import { RecoverPasscodeRequestBuilder } from './recoverPasscode/recoverPasscodeRequestBuilder';
import { RemoteLockRequestBuilder } from './remoteLock/remoteLockRequestBuilder';
import { RequestRemoteAssistanceRequestBuilder } from './requestRemoteAssistance/requestRemoteAssistanceRequestBuilder';
import { ResetPasscodeRequestBuilder } from './resetPasscode/resetPasscodeRequestBuilder';
import { RetireRequestBuilder } from './retire/retireRequestBuilder';
import { ShutDownRequestBuilder } from './shutDown/shutDownRequestBuilder';
import { SyncDeviceRequestBuilder } from './syncDevice/syncDeviceRequestBuilder';
import { UpdateWindowsDeviceAccountRequestBuilder } from './updateWindowsDeviceAccount/updateWindowsDeviceAccountRequestBuilder';
import { UsersRequestBuilder } from './users/usersRequestBuilder';
import { WindowsDefenderScanRequestBuilder } from './windowsDefenderScan/windowsDefenderScanRequestBuilder';
import { WindowsDefenderUpdateSignaturesRequestBuilder } from './windowsDefenderUpdateSignatures/windowsDefenderUpdateSignaturesRequestBuilder';
import { WindowsProtectionStateRequestBuilder } from './windowsProtectionState/windowsProtectionStateRequestBuilder';
import { WipeRequestBuilder } from './wipe/wipeRequestBuilder';
import { BaseRequestBuilder, RequestInformation, type RequestAdapter, type RequestConfiguration } from '@microsoft/kiota-abstractions';
export interface ManagedDeviceItemRequestBuilderGetQueryParameters {
    /**
     * Expand related entities
     */
    expand?: string[];
    /**
     * Select properties to be returned
     */
    select?: string[];
}
/**
 * Provides operations to manage the managedDevices property of the microsoft.graph.user entity.
 */
export declare class ManagedDeviceItemRequestBuilder extends BaseRequestBuilder {
    /**
     * Provides operations to call the bypassActivationLock method.
     */
    get bypassActivationLock(): BypassActivationLockRequestBuilder;
    /**
     * Provides operations to call the cleanWindowsDevice method.
     */
    get cleanWindowsDevice(): CleanWindowsDeviceRequestBuilder;
    /**
     * Provides operations to call the deleteUserFromSharedAppleDevice method.
     */
    get deleteUserFromSharedAppleDevice(): DeleteUserFromSharedAppleDeviceRequestBuilder;
    /**
     * Provides operations to manage the deviceCategory property of the microsoft.graph.managedDevice entity.
     */
    get deviceCategory(): DeviceCategoryRequestBuilder;
    /**
     * Provides operations to manage the deviceCompliancePolicyStates property of the microsoft.graph.managedDevice entity.
     */
    get deviceCompliancePolicyStates(): DeviceCompliancePolicyStatesRequestBuilder;
    /**
     * Provides operations to manage the deviceConfigurationStates property of the microsoft.graph.managedDevice entity.
     */
    get deviceConfigurationStates(): DeviceConfigurationStatesRequestBuilder;
    /**
     * Provides operations to call the disableLostMode method.
     */
    get disableLostMode(): DisableLostModeRequestBuilder;
    /**
     * Provides operations to call the locateDevice method.
     */
    get locateDevice(): LocateDeviceRequestBuilder;
    /**
     * Provides operations to manage the logCollectionRequests property of the microsoft.graph.managedDevice entity.
     */
    get logCollectionRequests(): LogCollectionRequestsRequestBuilder;
    /**
     * Provides operations to call the logoutSharedAppleDeviceActiveUser method.
     */
    get logoutSharedAppleDeviceActiveUser(): LogoutSharedAppleDeviceActiveUserRequestBuilder;
    /**
     * Provides operations to call the rebootNow method.
     */
    get rebootNow(): RebootNowRequestBuilder;
    /**
     * Provides operations to call the recoverPasscode method.
     */
    get recoverPasscode(): RecoverPasscodeRequestBuilder;
    /**
     * Provides operations to call the remoteLock method.
     */
    get remoteLock(): RemoteLockRequestBuilder;
    /**
     * Provides operations to call the requestRemoteAssistance method.
     */
    get requestRemoteAssistance(): RequestRemoteAssistanceRequestBuilder;
    /**
     * Provides operations to call the resetPasscode method.
     */
    get resetPasscode(): ResetPasscodeRequestBuilder;
    /**
     * Provides operations to call the retire method.
     */
    get retire(): RetireRequestBuilder;
    /**
     * Provides operations to call the shutDown method.
     */
    get shutDown(): ShutDownRequestBuilder;
    /**
     * Provides operations to call the syncDevice method.
     */
    get syncDevice(): SyncDeviceRequestBuilder;
    /**
     * Provides operations to call the updateWindowsDeviceAccount method.
     */
    get updateWindowsDeviceAccount(): UpdateWindowsDeviceAccountRequestBuilder;
    /**
     * Provides operations to manage the users property of the microsoft.graph.managedDevice entity.
     */
    get users(): UsersRequestBuilder;
    /**
     * Provides operations to call the windowsDefenderScan method.
     */
    get windowsDefenderScan(): WindowsDefenderScanRequestBuilder;
    /**
     * Provides operations to call the windowsDefenderUpdateSignatures method.
     */
    get windowsDefenderUpdateSignatures(): WindowsDefenderUpdateSignaturesRequestBuilder;
    /**
     * Provides operations to manage the windowsProtectionState property of the microsoft.graph.managedDevice entity.
     */
    get windowsProtectionState(): WindowsProtectionStateRequestBuilder;
    /**
     * Provides operations to call the wipe method.
     */
    get wipe(): WipeRequestBuilder;
    /**
     * Instantiates a new ManagedDeviceItemRequestBuilder and sets the default values.
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     */
    constructor(pathParameters: Record<string, unknown> | string | undefined, requestAdapter: RequestAdapter);
    /**
     * Delete navigation property managedDevices for users
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     */
    delete(requestConfiguration?: RequestConfiguration<object> | undefined): Promise<void>;
    /**
     * The managed devices associated with the user.
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of ManagedDevice
     */
    get(requestConfiguration?: RequestConfiguration<ManagedDeviceItemRequestBuilderGetQueryParameters> | undefined): Promise<ManagedDevice | undefined>;
    /**
     * Update the navigation property managedDevices in users
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of ManagedDevice
     */
    patch(body: ManagedDevice, requestConfiguration?: RequestConfiguration<object> | undefined): Promise<ManagedDevice | undefined>;
    /**
     * Delete navigation property managedDevices for users
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toDeleteRequestInformation(requestConfiguration?: RequestConfiguration<object> | undefined): RequestInformation;
    /**
     * The managed devices associated with the user.
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toGetRequestInformation(requestConfiguration?: RequestConfiguration<ManagedDeviceItemRequestBuilderGetQueryParameters> | undefined): RequestInformation;
    /**
     * Update the navigation property managedDevices in users
     * @param body The request body
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toPatchRequestInformation(body: ManagedDevice, requestConfiguration?: RequestConfiguration<object> | undefined): RequestInformation;
    /**
     * Returns a request builder with the provided arbitrary URL. Using this method means any other path or query parameters are ignored.
     * @param rawUrl The raw URL to use for the request builder.
     * @returns a ManagedDeviceItemRequestBuilder
     */
    withUrl(rawUrl: string): ManagedDeviceItemRequestBuilder;
}
