"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReminderViewWithStartDateTimeWithEndDateTimeRequestBuilder = void 0;
const oDataError_1 = require("../../../models/oDataErrors/oDataError");
const reminderViewWithStartDateTimeWithEndDateTimeGetResponse_1 = require("./reminderViewWithStartDateTimeWithEndDateTimeGetResponse");
const kiota_abstractions_1 = require("@microsoft/kiota-abstractions");
/**
 * Provides operations to call the reminderView method.
 */
class ReminderViewWithStartDateTimeWithEndDateTimeRequestBuilder extends kiota_abstractions_1.BaseRequestBuilder {
    /**
     * Instantiates a new ReminderViewWithStartDateTimeWithEndDateTimeRequestBuilder and sets the default values.
     * @param EndDateTime Usage: EndDateTime='{EndDateTime}'
     * @param pathParameters The raw url or the Url template parameters for the request.
     * @param requestAdapter The request adapter to use to execute the requests.
     * @param StartDateTime Usage: StartDateTime='{StartDateTime}'
     */
    constructor(pathParameters, requestAdapter, endDateTime, startDateTime) {
        super(pathParameters, requestAdapter, "{+baseurl}/users/{user%2Did}/reminderView(StartDateTime='{StartDateTime}',EndDateTime='{EndDateTime}'){?%24top,%24skip,%24search,%24filter,%24count}");
        this.pathParameters["EndDateTime"] = endDateTime;
        this.pathParameters["StartDateTime"] = startDateTime;
    }
    ;
    /**
     * Invoke function reminderView
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a Promise of ReminderViewWithStartDateTimeWithEndDateTimeGetResponse
     */
    get(requestConfiguration) {
        const requestInfo = this.toGetRequestInformation(requestConfiguration);
        const errorMapping = {
            "4XX": oDataError_1.createODataErrorFromDiscriminatorValue,
            "5XX": oDataError_1.createODataErrorFromDiscriminatorValue,
        };
        return this.requestAdapter.sendAsync(requestInfo, reminderViewWithStartDateTimeWithEndDateTimeGetResponse_1.createReminderViewWithStartDateTimeWithEndDateTimeGetResponseFromDiscriminatorValue, errorMapping);
    }
    ;
    /**
     * Invoke function reminderView
     * @param requestConfiguration Configuration for the request such as headers, query parameters, and middleware options.
     * @returns a RequestInformation
     */
    toGetRequestInformation(requestConfiguration) {
        const requestInfo = new kiota_abstractions_1.RequestInformation(kiota_abstractions_1.HttpMethod.GET, this.urlTemplate, this.pathParameters);
        requestInfo.configure(requestConfiguration, reminderViewWithStartDateTimeWithEndDateTimeRequestBuilderGetQueryParametersMapper);
        requestInfo.headers.tryAdd("Accept", "application/json");
        return requestInfo;
    }
    ;
    /**
     * Returns a request builder with the provided arbitrary URL. Using this method means any other path or query parameters are ignored.
     * @param rawUrl The raw URL to use for the request builder.
     * @returns a reminderViewWithStartDateTimeWithEndDateTimeRequestBuilder
     */
    withUrl(rawUrl) {
        if (!rawUrl)
            throw new Error("rawUrl cannot be undefined");
        return new ReminderViewWithStartDateTimeWithEndDateTimeRequestBuilder(rawUrl, this.requestAdapter);
    }
    ;
}
exports.ReminderViewWithStartDateTimeWithEndDateTimeRequestBuilder = ReminderViewWithStartDateTimeWithEndDateTimeRequestBuilder;
const reminderViewWithStartDateTimeWithEndDateTimeRequestBuilderGetQueryParametersMapper = {
    "count": "%24count",
    "filter": "%24filter",
    "search": "%24search",
    "skip": "%24skip",
    "top": "%24top",
};
// tslint:enable
// eslint-enable
