import { type ItemBody } from '../../../../models/itemBody';
import { type KeyValuePair } from '../../../../models/keyValuePair';
import { type TeamworkActivityTopic } from '../../../../models/teamworkActivityTopic';
import { type AdditionalDataHolder, type Parsable, type ParseNode, type SerializationWriter } from '@microsoft/kiota-abstractions';
export declare function createSendActivityNotificationPostRequestBodyFromDiscriminatorValue(parseNode: ParseNode | undefined): typeof deserializeIntoSendActivityNotificationPostRequestBody;
export declare function deserializeIntoSendActivityNotificationPostRequestBody(sendActivityNotificationPostRequestBody?: SendActivityNotificationPostRequestBody | undefined): Record<string, (node: ParseNode) => void>;
export interface SendActivityNotificationPostRequestBody extends AdditionalDataHolder, Parsable {
    /**
     * The activityType property
     */
    activityType?: string;
    /**
     * Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
     */
    additionalData?: Record<string, unknown>;
    /**
     * The chainId property
     */
    chainId?: number;
    /**
     * The previewText property
     */
    previewText?: ItemBody;
    /**
     * The templateParameters property
     */
    templateParameters?: KeyValuePair[];
    /**
     * The topic property
     */
    topic?: TeamworkActivityTopic;
}
export declare function serializeSendActivityNotificationPostRequestBody(writer: SerializationWriter, sendActivityNotificationPostRequestBody?: SendActivityNotificationPostRequestBody | undefined): void;
